import React from 'react';
import MyAlgo from '@randlabs/myalgo-connect';

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var styles = {"AlgoButton":"_1E3Mb","AlgoSendButton":"_uMOg7"};

var Pipeline = /*#__PURE__*/function () {
  function Pipeline() {}

  Pipeline.init = function init() {
    return new MyAlgo();
  };

  Pipeline.connect = function connect(wallet) {
    try {
      return Promise.resolve(_catch(function () {
        return Promise.resolve(wallet.connect()).then(function (accounts) {
          var item1 = accounts[0];
          item1 = item1['address'];
          return item1;
        });
      }, function (err) {
        console.error(err);
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  Pipeline.send = function send(address, amt, myNote, sendingAddress, wallet, index) {
    if (index === void 0) {
      index = 0;
    }

    try {
      var algodToken = '0';
      var paramServer = 'https://algoexplorerapi.io/v2/transactions/params';
      var transServer = 'https://algoexplorerapi.io/v2/transactions';
      var buf = new Array(myNote.length);
      var encodedNote = new Uint8Array(buf);

      for (var i = 0, strLen = myNote.length; i < strLen; i++) {
        encodedNote[i] = myNote.charCodeAt(i);
      }

      console.log('My encoded note: ' + encodedNote);
      return Promise.resolve(_catch(function () {
        return Promise.resolve(fetch(paramServer)).then(function (_fetch) {
          return Promise.resolve(_fetch.json()).then(function (params) {
            var txn = {
              from: sendingAddress,
              to: address,
              amount: parseInt(amt),
              note: encodedNote,
              genesisID: 'mainnet-v1.0',
              genesisHash: 'wGHE2Pwdvd7S12BL5FaOP20EGYesN73ktiC1qzkkit8=',
              type: 'pay',
              flatFee: true,
              fee: 1000,
              firstRound: params['last-round'],
              lastRound: params['last-round'] + 1000
            };

            if (index !== 0) {
              txn.type = 'axfer';
              txn.assetIndex = parseInt(index);
            }

            console.log(txn);
            return Promise.resolve(wallet.signTransaction(txn)).then(function (signedTxn) {
              return Promise.resolve(fetch(transServer, {
                method: 'POST',
                headers: {
                  'Content-Type': 'application/x-binary'
                },
                body: signedTxn.blob
              }).then(function (response) {
                return response.json();
              }).then(function (data) {
                return JSON.stringify(data.txId);
              })["catch"](function (error) {
                console.error('Error:', error);
              }));
            });
          });
        });
      }, function (err) {
        console.error(err);
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return Pipeline;
}();
var AlgoSendButton = function AlgoSendButton(_ref) {
  var index = _ref.index,
      recipient = _ref.recipient,
      amount = _ref.amount,
      note = _ref.note,
      myAddress = _ref.myAddress,
      wallet = _ref.wallet,
      context = _ref.context,
      returnTo = _ref.returnTo;
  return /*#__PURE__*/React.createElement("button", {
    className: styles.AlgoSendButton,
    onClick: function onClick() {
      Pipeline.send(recipient, parseInt(amount), note, myAddress, wallet, index).then(function (data) {
        if (typeof data !== 'undefined') {
          var object = {};
          object[returnTo] = data;
          context.setState(object);
        }
      });
    }
  }, "Send");
};
var AlgoButton = function AlgoButton(_ref2) {
  var wallet = _ref2.wallet,
      context = _ref2.context,
      returnTo = _ref2.returnTo;
  return /*#__PURE__*/React.createElement("button", {
    className: styles.AlgoButton,
    onClick: function onClick() {
      Pipeline.connect(wallet).then(function (accounts) {
        var data = {};
        data[returnTo] = accounts;
        context.setState(data);
      });
    }
  }, "Connect to MyAlgo");
};

export { AlgoButton, AlgoSendButton, Pipeline };
//# sourceMappingURL=index.modern.js.map
